package fr.username404.snowygui.fabric

import fr.username404.snowygui.gui.feature.Zoom
import net.fabricmc.loader.api.FabricLoader

@JvmField
var isOkZoomerPresent: Boolean = FabricLoader.getInstance().isModLoaded("okzoomer")
private val okZoomerPairs by lazy {
    with(Class.forName("io.github.ennuil.okzoomer.utils.ZoomUtils").getDeclaredField("ZOOMER_ZOOM")) {
        get(null).javaClass.run {
            (getDeclaredField("zoomDivisor") to this@with.get(null)) to (getDeclaredField("zoom") to this@with.get(null))
        }
    }.apply { first.first.isAccessible = true; second.first.isAccessible = true; }
}

fun fabricZoom() {
    try {
        with(okZoomerPairs) {
            first.run { first.setFloat(second, Zoom.zoomFactor.toFloat()) }
            second.run { first.setBoolean(second, Zoom.toggled) }
        }
    } catch (e: Exception) {
        isOkZoomerPresent = false
    }
}